/* File "Progetto.java"
 * 
 * Istruzioni:
 * 0. Scrivete di seguito il vostro nome e cognome
 *
 * ### Nome: >>> MODIFICA QUI <<<
 * ### Cognome: >>> MODIFICA QUI <<<
 * ### Matricola: >>> MODIFICA QUI <<<
 *
 * 1. Questo codice, così come vi viene fornito ora non è funzionante.
 *    Per completare il progetto dove modificare e/o implementare le parti che
 *    trovate indicate con le scritte:
 *    >>> INSERISCI IL TUO CODICE QUI <<<
 *    oppure
 *    >>> MODIFICA QUI <<<
 *
 * 2. Non modificate o cancellate nulla al di fuori dei punti in cui è esplicitamente indicato.
 *    Questo vale per *tutti* gli elementi del codice compresi commenti, dichiarazioni di funzioni,
 *    ecc.;
 *
 * 3. Potete utilizzare tutte le librerie di Java. Potete usare anche caratteristiche di Java non
 *    viste a lezione (costrutti, librerie, ...), anche se il progetto si può svolgere benissimo
 *    anche senza.
 *    Dovete però comprendere il codice che state usando: se venite chiamati ad un colloquio vi
 *    può essere chiesto di spiegarlo.
 *
 * 4. Se volete, potete usare anche altre classi in altri file .java.  Non usate "package",
 *    create tutte le classi in quello di default (che contiene anche questo file);
 *
 */

/*
 *
 * Qui potete importare le librerie di Java necessari all'esecuzione del programma.
 *
 */
>>> INSERISCI IL TUO CODICE QUI <<<

public class Progetto {

	/*
	 * La funzione distanze non deve interagire con l'utente (chiedere
	 * all'utente dati, aprire finestre, ecc).
	 *
	 * È permesso l'output di messaggi su console (che verranno ignorati da chi
	 * corregge).
	 *
	 * La funzione main, se usata, può interagire con l'utente (ma non sarà
	 * considerata da chi corregge).
	 *
	 */
	public static int[] distanze(String nomeFile) throws FileNotFoundException {
		// Scrivete qui la vostra soluzione al problema

		>>> INSERISCI IL TUO CODICE QUI <<<


	}

	/*
	 * Create un file di output che contenga i risultati (ovvero le distanze dal
	 * nodo 0). Questo file è di una riga, ed elenca tutte le distanze
	 * separandole con uno spazio:
	 *
	 *     distanza0 distanza1 ... distanzaN-1
	 *
	 * La prima distanza ovviamente è 0.
	 *
	 * Il file si chiamerà come l'input senza estensione e seguito da
	 * "_output.txt". Per facilitarvi abbiamo già scritto le operazioni
	 * necessarie a generare il nome del file di output che trovate nella
	 * variabile outputFileName.
	 *
	 */
	public static void scritturaOutput(String inputFileName, int r[]) throws IOException {

		int lastDotPos = inputFileName.lastIndexOf('.');
		int endIndex =  lastDotPos > 0 ? lastDotPos : inputFileName.length();

		// outputFileName è una stringa che contiene il nome del file di output.
		String outputFileName = inputFileName.substring(0, endIndex) + "_output.txt";

		>>> INSERISCI IL TUO CODICE QUI <<<

	}

	/*
	 * Qui potete aggiungere altri metodi/funzioni, se volete
	 *
	 */

	/*
	 * Il metodo distanze di sopra deve comunque funzionare anche se viene
	 * invocato da un main diverso da quello che scrivete voi. Per esempio, il
	 * vostro main NON deve inizializzare variabili che poi vengono usate dentro
	 * distanze (inizializzatele direttamente là).
	 *
	 */
	public static void main(String[] args) throws IOException {

		int[] r;
		int i;

		/*
		 * Nome del file di input con percorso (path).
		 *
		 * Esempi:
		 *
		 * (sistemi *nix: Linux, Mac OS X)
		 *
		 * String inputFileName = "esempio01.txt";
		 *
		 * String inputFileName = "/tmp/esempio01.txt";
		 *
		 * (Windows)
		 *
		 * String inputFileName = "esempio01_win.txt";
		 *
		 * String inputFileName = "C:\Users\cristian\info\esempio01_win.txt";
		 *
		 */

		String inputFileName = // >>>MODIFICA QUI <<<

		if (args.length != 0) {
			inputFileName = args[0];
		}

		System.out.printf("Il file di input è: %s.%n", inputFileName);

		r = distanze(inputFileName);

		for (i = 0; i < r.length; i++) {
			System.out.println(r[i]);
		}

		scritturaOutput(inputFileName, r);
	}
}
